<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Teknisa\CRM\Service\ComunicacaoService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class ComunicacaoController extends TeknisaCrud {

    protected $comunicacaoService;
    protected $crudService;
    protected $dataSourceName = 'comunicaparc_formacomu';
    protected $dataSourceNameSet = 'comunicaparc_parcnegocio';
    protected $parameterBagColumns = array("P_NRPARCNEGOCIO", "P_NRORG");

    public function __construct($crudService, ParameterBag $parameterBag, ComunicacaoService $comunicacaoService) {
        $this->crudService = $crudService;
        $this->comunicacaoService = $comunicacaoService;
        parent::__construct($crudService, $parameterBag);
    }

    public function save(DTO\Request $request, DTO\Response $response) {
        try {
            $this->dataSourceName = $this->dataSourceNameSet;
            $row = $request->getRow();
            $nrcomunicaparc = $this->comunicacaoService->validateComunicacao($row);
            parent::save($request, $response);
            if ($row['__is_new']) {
                $response->addDataset(new DataSet('columnsToReturn', $this->crudService->getColumnsToReturn()[0]));
            }
        }
        catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

}