<?php
namespace Teknisa\CRM\Controller;

//use Generated\Controller\Vendedor;
use Teknisa\CRM\Service\SecurityService;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Method;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;

class Login
{
    protected  $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function login($request, $response)
    {
        $service = new SecurityService($this->entityManager);
        $filters = $request->getFilterCriteria()->getConditions();
        $CDOPERADOR  = $filters[0]["value"];
        $CDSENHAOPER = $filters[1]["value"];

        if ($service->validateOperador($CDOPERADOR) === false) {
            $response->addMessage(new Message("Operador Inválido"));
        } else if ($service->validateSenha($CDOPERADOR, $CDSENHAOPER) === false) {
            $response->addMessage(new Message("Senha Inválida"));
        } else {
            $session = new \Zeedhi\Framework\Session\Session();

            $cdoperador        = $service->getCdoperador();
            $nmoperador        = $service->getNmoperador();
            $nrGroupCtlAcess   = $service->getNrGroupCtlAcess();
            $nrParcNegocio     = $service->getNrParcNegocio();
            $nrOrg             = $service->getNrorg();
            $cdfilial          = $service->getCdfilial();

            $session->set('operator', $cdoperador);
            $session->set('nmoperador', $nmoperador);
            $session->set('nrGroupCtlAcess', $nrGroupCtlAcess);
            $session->set('nrParcNegocio', $nrParcNegocio);
            $session->set('nrorg', $nrOrg);
            $session->set('cdfilial', $cdfilial);

            $response->addMethod(new Method('setLocalVar', array('CDOPERADOR', $cdoperador)));
            $response->addMethod(new Method('setLocalVar', array('NRORG', $nrOrg)));
            $response->addMethod(new Method('setLocalVar', array('NRPARCNEGOCIO', $nrParcNegocio)));
            $response->addMethod(new Method('setLocalVar', array('CDFILIAL', $cdfilial)));
            $response->addMethod(new Method('setLocalVar', array('NMOPERADOR', $nmoperador)));
            $response->addMethod(new Method('setLocalVar', array('NRGROUPCTLACESS', $nrGroupCtlAcess)));

            // define grupo de controle de acesso do operador
            $response->addDataSet(new DataSet('login', array($nrGroupCtlAcess)));

            // define nome do operador para o UserInfo do menu
            $response->addDataSet(new DataSet('userData', array('nmoperador' => $nmoperador)));
        }
    }

}