/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_RISCOPROJETO                                             */
/* Tabela : RISCOPROJETO                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 23/11/2007 - Pedro Nerino Viol de Lima                                     */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_RISCOPROJETO
BEFORE INSERT OR UPDATE OR DELETE
ON RISCOPROJETO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATURPRJ := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.IDPRORISPROJ, 0) <> NVL(:NEW.IDPRORISPROJ, 0)) OR
         (NVL(:OLD.IDIMPRISPROJ, 0) <> NVL(:NEW.IDIMPRISPROJ, 0)) THEN
         :NEW.DTULTATURPRJ := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
        VALUES ('RISCOPROJETO', '', 'CDFILIAL='||:OLD.CDFILIAL||';CDPROJETO'||:OLD.CDPROJETO||
                ';NRBASELINEPR='||:OLD.NRBASELINEPR||';CDGRPOCOR='||:OLD.CDGRPOCOR||
                ';CDOCORR'||:OLD.CDOCORR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE RISCOPROJETO MODIFY DTULTATURPRJ DEFAULT SYSDATE
/


-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_RISCOPROJETO','5.01.001'); END;
/

