/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_COBAIA                                                   */
/* Tabela : COBAIA                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 03/12/2004 - JOAO PAULO REIS                                               */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_COBAIA' and
            type = 'TR'             and
            u.uid = o.uid           and
            u.name = USER)
   DROP TRIGGER DTULTATU_COBAIA
GO

CREATE TRIGGER DTULTATU_COBAIA
ON COBAIA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                          			      (SELECT 'COBAIA', null, 'CDCOBAIA ='+ CDCOBAIA + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE COBAIA
      SET DTULTATUCOBA = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(COBAIA.CDCOBAIA,0) = ISNULL(INSERTED.CDCOBAIA,0)) AND
            (ISNULL(COBAIA.NMCOBAIA,0) = ISNULL(INSERTED.NMCOBAIA,0)) AND
            (ISNULL(COBAIA.IDSEXOCOBAIA,0) = ISNULL(INSERTED.IDSEXOCOBAIA,0)) AND
            (ISNULL(COBAIA.DTNASCCOBAIA,CONVERT(DATETIME,'31/12/1899')) =
             ISNULL(INSERTED.DTNASCCOBAIA,CONVERT(DATETIME,'31/12/1899')))  AND
            (ISNULL(COBAIA.DTOBITCOBAIA,CONVERT(DATETIME,'31/12/1899')) =
             ISNULL(INSERTED.DTOBITCOBAIA,CONVERT(DATETIME,'31/12/1899')))  AND
            (ISNULL(COBAIA.CDCOBAIAMAE,0) = ISNULL(INSERTED.CDCOBAIAMAE,0)) AND
            (ISNULL(COBAIA.CDCOBAIAPAI,0) = ISNULL(INSERTED.CDCOBAIAPAI,0)) AND
            (ISNULL(COBAIA.CDESPEANIMAL,0) = ISNULL(INSERTED.CDESPEANIMAL,0))
   END;
END;
GO
