function Ger01500_municipio(ScreenService, General, Ger01500_Municipio_Service){

    this.filtraEstado = function(widget){
        widget.getField('NMESTADO').readOnly    = widget.currentRow.CDPAIS?false:true;
        widget.getField('NMMUNICIPIO').readOnly = true;
        
        widget.currentRow.SGESTADO = '';
        widget.currentRow.NMESTADO = '';
        widget.currentRow.CDMUNICIPIO ='';
        widget.currentRow.NMMUNICIPIO ='';
        
		widget.getField('NMESTADO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
    };
    
    this.filtraMunicipio = function(widget){
        widget.getField('NMMUNICIPIO').readOnly    = widget.currentRow.SGESTADO?false:true;
        
        widget.currentRow.CDMUNICIPIO ='';
        widget.currentRow.NMMUNICIPIO ='';
        
		widget.getField('NMMUNICIPIO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
		widget.getField('NMMUNICIPIO').dataSourceFilter[1].value = widget.currentRow.SGESTADO;
    };
    
    this.blockFields = function(args){
        var widget = args.owner;
        widget.getField('NMPAIS').readOnly = true;
        widget.getField('NMESTADO').readOnly = true;
    };

    this.takeLocations = function(widget){
        var popupCurrentRow = widget.appliedFilter.FILTER_ROW;
        widget.currentRow.NMPAIS = popupCurrentRow.NMPAIS;
        widget.currentRow.CDPAIS = popupCurrentRow.CDPAIS;
        widget.currentRow.NMESTADO = popupCurrentRow.NMESTADO;
        widget.currentRow.SGESTADO = popupCurrentRow.SGESTADO;
    };

    this.salvarMunicipio = function (widget){
        if(widget.currentRow.CDPAIS && widget.currentRow.SGESTADO){
            if(widget.isValid()){
                Ger01500_Municipio_Service.salvarMunicipio(widget.currentRow).then(function(Success) {
                    this.controlaStatusWidgets(widget,'municipio',true); 
                    if (widget.currentRow.__is_new) {
                        widget.reload().then(function() {
                            widget.list(true);
                            ScreenService.closeSwipe();
                        });
                    }
                    else {
                        widget.view();
                    }
                }.bind(this),
                function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                });
            }   
        }else{
            ScreenService.showMessage('Campos do filtro não preenchidos.');
        }
       
    };
    
    this.addBairro = function (widget){
        var widgetMunicipio           = widget.getParent();
        var filtro =  {
            "CDPAIS"     : widgetMunicipio.currentRow.CDPAIS,
            "SGESTADO"   : widgetMunicipio.currentRow.SGESTADO,
            "CDMUNICIPIO": widgetMunicipio.currentRow.CDMUNICIPIO
        };
        widget.newRow();
        Ger01500_Municipio_Service.novoCodigoBairro(filtro).then(
            function(success) {
                var codigo                    = formatCdbairro(String (success.dataset.CDBAIRRO.CDBAIRRO[0].MAIORBAIRRO));
                widget.currentRow.CDBAIRRO    = codigo.substring(0,10);
                widget.currentRow.CDPAIS      = widgetMunicipio.currentRow.CDPAIS;
                widget.currentRow.SGESTADO    = widgetMunicipio.currentRow.SGESTADO;
                widget.currentRow.CDMUNICIPIO = widgetMunicipio.currentRow.CDMUNICIPIO;
            },
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
       
    };
    
    function formatCdbairro (string){
        switch (string.length){
            case 1:
                return '000000000' + string;
            case 2:
                return '00000000' + string;
            case 3:
                return '0000000' + string;
            case 4:
                return '000000' + string;
            case 5:
                return '00000' + string;
            case 6:
                return '0000' + string;
            case 7:
                return '000' + string;
            case 8:
                return '00' + string;
            case 9:
                return '0' + string;
            case 10:
                return string;
        }
    }
    
    this.addMunicipio = function (widget){
        var filtro = widget.appliedFilter.FILTER_ROW;
        widget.newRow();
        widget.currentRow.CDPAIS   = filtro.CDPAIS;
        widget.currentRow.SGESTADO = filtro.SGESTADO;
        this.controlaStatusWidgets(widget,'municipio',false); 
    };
    
    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if(mainWidget.name !== nomeWidgetAtual)
            mainWidget.enabled = status;
    };
    
    this.salvarBairro = function (widget){
        if(widget.isValid()){
            if(widget.currentRow.QTHORAENTREGA)
                widget.currentRow.QTHORAENTREGA = widget.currentRow.QTHORAENTREGA.replace(/[^0-9]/g,'');
            General.saveCrud(widget);
            
        }
    };
    
    this.addRegiao = function (widget){
        var widgetMunicipio           = widget.getParent();
        var filtro =  {
            "CDPAIS"     : widgetMunicipio.currentRow.CDPAIS,
            "SGESTADO"   : widgetMunicipio.currentRow.SGESTADO,
            "CDMUNICIPIO": widgetMunicipio.currentRow.CDMUNICIPIO
        };
        widget.newRow();
        Ger01500_Municipio_Service.novoCodigoRegiao(filtro).then(
            function(success) {
                var codigo                     = formatCdregiaoMuni(String(success.dataset.CDREGIAOMUNI.CDREGIAOMUNI[0].MAIORREGIAO));
                widget.currentRow.CDREGIAOMUNI = codigo.substring(0,4);
                widget.currentRow.CDPAIS       = widgetMunicipio.currentRow.CDPAIS;
                widget.currentRow.SGESTADO     = widgetMunicipio.currentRow.SGESTADO;
                widget.currentRow.CDMUNICIPIO  = widgetMunicipio.currentRow.CDMUNICIPIO;
            },
            function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
       
    };
    
    function formatCdregiaoMuni (string){
        switch (string.length){
            case 1:
                return '000' + string;
            case 2:
                return '00' + string;
            case 3:
                return '0' + string;
        }
    }
    
    this.recarrecarWidgetsFilhas = function (widget){
        if(! widget.currentRow.__is_new){
            widget.widgets.forEach(function(widg) {
                widg.reload();
            });
        }
    };
    
    this.filtraEstadoFilter = function(field){
        var fieldEstado = field.widget.container.getWidget('municipio').getField('NMESTADO');
        
        			var estado =field.widget.container.getWidget('municipio').getField('NMESTADO');
		estado.dataSourceFilter[0].value = widget.currentRow.CDPAIS;
		estado.reload();
        
        
        var country = field.widget.container.getWidget('municipio');

        field.getParent().getField('NMESTADO').readOnly    = country.currentRow.CDPAIS?false:true;
        field.getParent().getField('NMMUNICIPIO').readOnly = true;
        
        field.getParent().getField('NMESTADO').value('');
        
        country.currentRow.NMMUNICIPIO ='';
        country.currentRow.CDMUNICIPIO ='';

        country.currentRow.SGESTADO = '';
        
    };
    
    this.filtraMunicipioFilter = function(field){
        var fieldMunicipio = field.widget.container.getWidget('municipio').getField('NMMUNICIPIO');
        var country = field.widget;

        if(country.currentRow.CDPAIS && country.currentRow.SGESTADO){
            field.getParent().getField('NMMUNICIPIO').readOnly = false;

        }else{
            field.getParent().getField('NMMUNICIPIO').readOnly = true;
        }
        


    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger01500_municipio', Ger01500_municipio);
});